//SlotGame.java
//Carlos O. Rios
//Collaboration: I worked on the homework assignment alone, using only course materials.


import java.util.Random;

/**
* This class creates conditionals to simulate a virtual 
* slot machine. It simulates a spin of the slot machine and 
* calculates a score. It also simulates a test spin and
* calculates a score. The test spin has a higher
* probability of returning a high score than the play mode. 
* It also has methods to obtain and update the current holdings.  
* @author Carlos O. Rios
* @version 1.0
*/

public class SlotGame
{
	/**
	* @string drum1 is text representing the first drum result of the spin
	*/
	String drum1="";
	/**
	* @string drum2 is text representing the second drum result of the spin
	*/
	String drum2="";
	/**
	* @string drum3 is text representing the third drum result of the spin
	*/
	String drum3="";
	/**
	* @param playvalue is the size of the bet
	*/
	int playvalue;
	/**
	* @param currentholdings is the current value of the winnings
	*/
	int currentholdings;
	/**
	* @random generator is used to produce the random numbers associated with a spin
	*/
	Random generator;

	public SlotGame(int playvaluein, int currentholdingsin)
		{	
			playvalue=playvaluein;
			currentholdings=currentholdingsin;
			 generator=new Random();
		}	
			
	/**
	* This allows user to play the game one time in the normal mode
	* In the normal mode drums make take line values
	*/		
	public void  play()
	{	
	   /** 
		* This finds the value of the first drum
		*/
		int randnum=generator.nextInt(8);
		switch(randnum){
			case 0:
				drum1="Bell";
				break;
			case 1:
				drum1="Grape";
				break;
			case 2:
				drum1="Cherry";
				break;
			default:
				drum1="*****";
			}
		/**
		* This finds the value of the second drum
		*/
		randnum=generator.nextInt(8);
		switch(randnum){
			case 0:
				drum2="Bell";
				break;
			case 1:
				drum2="Grape";
				break;
			case 2:
				drum2="Cherry";
				break;
			default:
				drum2="*****";
			
			}

		/**
		* This finds the value of the third drum		
		*/
		randnum=generator.nextInt(8);
		switch(randnum){
			case 0:
				drum3="Bell";
				break;
			case 1:
				drum3="Grape";
				break;
			case 2:
				drum3="Cherry";
				break;
			default:
				drum3="*****";
				
			}

		calculateScore(drum1,drum2,drum3);
		
		}
		
	/** 
	* This plays the game using the test mode
	* Test mode drums are not allowed to have line values
	*/
	public void  test()
	{	
	/**
	This finds the value of the first drum
	*/
		int randnum=generator.nextInt(3);
		switch(randnum){
			case 0:
				drum1="Bell";
				break;
			case 1:
				drum1="Grape";
				break;
			case 2:
				drum1="Cherry";
				break;
			default:
				drum1="*****";
			}
		System.out.println(drum1);
		/**
		* This finds the value of the second drum
		*/
		randnum=generator.nextInt(3);
		switch(randnum){
			case 0:
				drum2="Bell";
				break;
			case 1:
				drum2="Grape";
				break;
			case 2:
				drum2="Cherry";
				break;
			default:
				drum2="*****";
			
			}
		System.out.println(drum2);
		/**
		* This finds the value of the third drum
		*/
				
		randnum=generator.nextInt(3);
		switch(randnum){
			case 0:
				drum3="Bell";
				break;
			case 1:
				drum3="Grape";
				break;
			case 2:
				drum3="Cherry";
				break;
			default:
				drum3="*****";
				
			}
		System.out.println(drum3);
		calculateScore(drum1,drum2,drum3);
		}
		
		/**
		* This calculates the score for one play
		* This also uses conditionals to make the multiple score combinations
		* @param score is the numerical score of the play based on the combination
		*/
	private void calculateScore(String drum1,String drum2,String drum3)
	{

		int score;
		if ((drum1 == "Bell")&&(drum2 == "Bell")&&(drum3 == "Bell"))
			{score=10;}
		else
			{	if ((drum1 == "Grape")&&(drum2 == "Grape")&&(drum3 == "Grape"))
				{score=7;}
				else
					{ if ((drum1 == "Cherry")&&(drum2 == "Cherry")&&(drum3 == "Cherry"))
						{score=5;}
						else
						{	if ((drum1 == "Cherry")&&(drum2 == "Cherry")&&(drum3 == "*****"))
							{score=3;}
							else
									{if ((drum1 == "Cherry")&&(drum2 == "*****")&&(drum3 == "Cherry"))
									{score=3;}
									else
											{if ((drum1 == "*****")&&(drum2 == "Cherry")&&(drum3 == "Cherry"))
												{score=3;}
											else
													{if ((drum1 == "Cherry")&&(drum2 == "*****")&&(drum3 == "*****"))
														{score=1;}
													else
														{if ((drum1 == "*****")&&(drum2 == "Cherry")&&(drum3 == "*****"))
															{score=1;}
														else
																{if ((drum1 == "*****")&&(drum2 == "*****")&&(drum3 == "Cherry"))	
																 {score=1;}
																 else
																 {score=0;}
																 }
														}
													}
												}
										}
									}
							}
					}
		
		
										
		/**
		* This calculates the current holdings after the play
		*/
	
		if (score==0)
		{currentholdings-=playvalue;}
		else
		{currentholdings+=(playvalue*score);}
									
		}	
		
		
	/**
	* This gets the value of the first drum
	*/
	public String getdrum1()
		{return drum1;}
	/**
	* This gets the value of the second drum
	*/
	public String getdrum2()
		{return drum2;}
	/**
	* This gets the value of the third drum
	*/
	public String getdrum3()
		{return drum3;}
	/**
	* @param getcurrentholdings brings up the user's current monetary holdings
	*/
	public int getcurrentholdings()
		{return currentholdings;}
	
		
}													 			